#ifndef TPETRA_KOKKOSCLASSIC_DEFAULTNODE_H
#define TPETRA_KOKKOSCLASSIC_DEFAULTNODE_H

// Tpetra's default Node type.
#define TPETRA_DEFAULTNODE Tpetra::KokkosCompat::KokkosOpenMPWrapperNode
// For backwards compatibility ONLY.
#define TPETRA_KOKKOSCLASSIC_DEFAULTNODE TPETRA_DEFAULTNODE

// Defined if and only if Tpetra's default execution space is Kokkos::Experimental::SYCL.
/* #undef HAVE_TPETRA_DEFAULTNODE_SYCLWRAPPERNODE */
// For backwards compatibility ONLY.
#ifdef HAVE_TPETRA_DEFAULTNODE_SYCLWRAPPERNODE
#  define HAVE_TPETRA_KOKKOSCLASSIC_DEFAULTNODE_SYCLWRAPPERNODE 1
#endif // HAVE_TPETRA_DEFAULTNODE_SYCLWRAPPERNODE

// Defined if and only if Tpetra's default execution space is Kokkos::HIP.
/* #undef HAVE_TPETRA_DEFAULTNODE_HIPWRAPPERNODE */
// For backwards compatibility ONLY.
#ifdef HAVE_TPETRA_DEFAULTNODE_HIPWRAPPERNODE
#  define HAVE_TPETRA_KOKKOSCLASSIC_DEFAULTNODE_HIPWRAPPERNODE 1
#endif // HAVE_TPETRA_DEFAULTNODE_HIPWRAPPERNODE

// Defined if and only if Tpetra's default execution space is Kokkos::Cuda.
/* #undef HAVE_TPETRA_DEFAULTNODE_CUDAWRAPPERNODE */
// For backwards compatibility ONLY.
#ifdef HAVE_TPETRA_DEFAULTNODE_CUDAWRAPPERNODE
#  define HAVE_TPETRA_KOKKOSCLASSIC_DEFAULTNODE_CUDAWRAPPERNODE 1
#endif // HAVE_TPETRA_DEFAULTNODE_CUDAWRAPPERNODE

// Defined if and only if Tpetra's default execution space is Kokkos::OpenMP.
#define HAVE_TPETRA_DEFAULTNODE_OPENMPWRAPPERNODE
// For backwards compatibility ONLY.
#ifdef HAVE_TPETRA_DEFAULTNODE_OPENMPWRAPPERNODE
#  define HAVE_TPETRA_KOKKOSCLASSIC_DEFAULTNODE_OPENMPWRAPPERNODE 1
#endif // HAVE_TPETRA_DEFAULTNODE_OPENMPWRAPPERNODE

// Defined if and only if Tpetra's default execution space is Kokkos::Threads.
/* #undef HAVE_TPETRA_DEFAULTNODE_THREADSWRAPPERNODE */
// For backwards compatibility ONLY.
#ifdef HAVE_TPETRA_DEFAULTNODE_THREADSWRAPPERNODE
#  define HAVE_TPETRA_KOKKOSCLASSIC_DEFAULTNODE_THREADSWRAPPERNODE 1
#endif // HAVE_TPETRA_DEFAULTNODE_THREADSWRAPPERNODE

// Defined if and only if Tpetra's default execution space is Kokkos::Serial.
/* #undef HAVE_TPETRA_DEFAULTNODE_SERIALWRAPPERNODE */
// For backwards compatibility ONLY.
#ifdef HAVE_TPETRA_DEFAULTNODE_SERIALWRAPPERNODE
#  define HAVE_TPETRA_KOKKOSCLASSIC_DEFAULTNODE_SERIALWRAPPERNODE 1
#endif // HAVE_TPETRA_DEFAULTNODE_SERIALWRAPPERNODE

#endif /* TPETRA_KOKKOSCLASSIC_DEFAULTNODE_H */
